#! /usr/bin/env python

import os, sys
import pygame
from pygame.locals import *
import math
import yumenokaze

if not pygame.font:
    print 'Warning, fonts disabled'
    fontEnable = 0
else : fontEnable = 1

#life = 3
#lives = []


class AstraMain:
    def __init__(self, width=640,height=480):
        pygame.init()

        pygame.display.set_caption("Astra")

        self.width = width
        self.height = height

        self.screen = pygame.display.set_mode((self.width, self.height))
        self.scrRect = self.screen.get_rect( )

        self.boundaryRect = pygame.Rect(self.scrRect)
        self.boundaryRect.top = 20
        self.boundaryRect.height = self.scrRect.height - 20

        self.lstPlanet = []
        self.lstBlackHole = []
        self.lstSlot = []

        self.clock = pygame.time.Clock()

        # Info de debug dans les differentes classes
        self.debug = 0
        Planet.debug = 0
        Astra.debug = 0

        #en attendant d'avoir un veritable menu de configuration
        self.language = "fr"

        self.translateText(self.language)
        
        self.textRender()

        #self.displayMenu()

        self.level = 0
        self.life = 3
        self.lives = []
        
    def mainLoop(self,level):
        #pygame.key.set_repeat(500,30)
        
        self.loadLevel(level)
        
        while 1:
            # Boucle de detection des touches appuyees
            for event in pygame.event.get():
                if event.type == pygame.QUIT: 
                    sys.exit()
                # Utiliser la pile des Events ne permet pas de detecter les appuis simultanes
                #elif event.type == KEYDOWN:
                    #if ((event.key == K_RIGHT)
                    #or (event.key == K_LEFT)
                    #or (event.key == K_UP)
                    #or (event.key == K_DOWN)):
                        #self.astra.move(event.key)
                elif event.type == KEYDOWN:
                    if (event.key == K_e): self.astra.changeMass(-1)
                    elif (event.key == K_r): self.astra.changeMass(1)
                    elif (event.key == K_p): self.pause()

            # On remet a zero les zones contenant des sprites
            self.clock.tick(30)
            for s in self.lstSlot:
                self.screen.blit(self.background,s.rect,s.rect)
            for p in self.lstPlanet:
                self.screen.blit(self.background,p.rect,p.rect)
            #self.screen.blit(self.background, self.astra.rect, self.astra.rect)
            for b in self.lstBlackHole:
                self.screen.blit(self.background,b.rect,b.rect)
            for life in self.lives:
                self.screen.blit(self.background,life.rect,life.rect)
            self.screen.blit(self.background, self.textpos[1],self.textpos[1])
            self.screen.blit(self.background, self.textpos[4],self.textpos[4])
            

            # Detection des touches de direction        
            if pygame.key.get_pressed()[K_ESCAPE]:
                self.__init__()
                self.displayMenu()
                #sys.exit()
            if pygame.key.get_pressed()[K_RIGHT]: self.astra.move(K_RIGHT)
            if pygame.key.get_pressed()[K_LEFT]: self.astra.move(K_LEFT)
            if pygame.key.get_pressed()[K_UP]: self.astra.move(K_UP)
            if pygame.key.get_pressed()[K_DOWN]: self.astra.move(K_DOWN)
            #if pygame.key.get_pressed()[K_e]: self.astra.changeMass(-1)
            #if pygame.key.get_pressed()[K_r]: self.astra.changeMass(1)
            

            # On applique les champs gravitationnels a chaque planete
            for p in self.lstPlanet:
                p.computeForces(self.lstPlanet, self.lstBlackHole)

            self.applyForces()

            #self.debug()
            self.checkSlots()
            
            # On blit les differents sprites
            for s in self.lstSlot:
                self.screen.blit(s.image,s.rect)            
            for p in self.lstPlanet:
                self.screen.blit(p.image,p.rect)            
            #self.screen.blit(self.astra.image, self.astra.rect)
            #self.screen.blit(self.mondo.image, self.mondo.rect)
            for b in self.lstBlackHole:
                self.screen.blit(b.image,b.rect)            

            for life in self.lives:
                self.screen.blit(life.image,life.rect)

            surfMassUnit=self.fontMassUnit.render("%s" % self.astra.massUnit,True,(255, 255, 255))
            self.text[1]=surfMassUnit
            surfMassExp=self.fontMassExp.render("%s" % self.astra.massExp,True,(255, 255, 255))
            self.text[4]=surfMassExp
            
            self.screen.blit(self.text[0], self.textpos[0])
            self.screen.blit(self.text[1], self.textpos[1])
            self.screen.blit(self.text[2], self.textpos[2])
            self.screen.blit(self.text[3], self.textpos[3])
            self.screen.blit(self.text[4], self.textpos[4])
            self.screen.blit(self.text[5], self.textpos[5])
            
            if self.slottedPlanets == len(self.lstSlot):
                self.levelCompleted()
            
            pygame.display.flip()

    def textRender(self):
        if fontEnable:
            pygame.font.init()
            self.fontLoose = pygame.font.Font("data/fonts/boombox2.ttf", 20)
            self.fontMass = pygame.font.Font("data/fonts/astronbi.ttf", 16)
            self.fontKG = pygame.font.Font("data/fonts/astronbo.ttf", 16)
            self.fontMassUnit = pygame.font.Font("data/fonts/boombox2.ttf", 10)
            self.fontMassExp = pygame.font.Font("data/fonts/boombox2.ttf", 8)
            self.fontMenu = pygame.font.Font("data/fonts/boombox2.ttf", 26)
            
            
            self.text = []
            self.textpos = []
            
            self.text.append(self.fontMass.render(self.label["mass"],True,(255, 255, 255)))
            self.textpos.append(self.text[len(self.text)-1].get_rect())
            self.textpos[len(self.text)-1].top = 0
            self.textpos[len(self.text)-1].left = 5

            self.text.append(self.fontMassUnit.render("1",True,(255, 255, 255)))
            self.textpos.append(self.text[len(self.text)-1].get_rect())
            self.textpos[len(self.text)-1].top = 0
            self.textpos[len(self.text)-1].left = self.textpos[len(self.text)-2].left + self.textpos[len(self.text)-2].width + 5

            self.text.append(self.fontKG.render("x",True,(255, 255, 255)))
            self.textpos.append(self.text[len(self.text)-1].get_rect())
            self.textpos[len(self.text)-1].top = 0        #self.textpos[len(self.text)-2].bottom
            self.textpos[len(self.text)-1].left = self.textpos[len(self.text)-2].left + self.textpos[len(self.text)-2].width 

            self.text.append(self.fontMassUnit.render("10",True,(255, 255, 255)))
            self.textpos.append(self.text[len(self.text)-1].get_rect())
            self.textpos[len(self.text)-1].top = 0
            self.textpos[len(self.text)-1].left = self.textpos[len(self.text)-2].left + self.textpos[len(self.text)-2].width

            self.text.append(self.fontMassExp.render("00",True,(255, 255, 255)))
            self.textpos.append(self.text[len(self.text)-1].get_rect())
            self.textpos[len(self.text)-1].top = 0
            self.textpos[len(self.text)-1].left = self.textpos[len(self.text)-2].left + self.textpos[len(self.text)-2].width

            self.text.append(self.fontKG.render("kg",True,(255, 255, 255)))
            self.textpos.append(self.text[len(self.text)-1].get_rect())
            self.textpos[len(self.text)-1].top = 0
            self.textpos[len(self.text)-1].left = self.textpos[len(self.text)-2].left + self.textpos[len(self.text)-2].width

            self.text.append(self.fontLoose.render(self.label["loose"],True,(255, 255, 255)))
            self.textpos.append(self.text[len(self.text)-1].get_rect())
            self.textpos[len(self.text)-1].centery = self.boundaryRect.top + self.boundaryRect.height/2
            self.textpos[len(self.text)-1].centerx = self.boundaryRect.left + self.boundaryRect.width/2
            
            self.text.append(self.fontLoose.render(self.label["pause"],True,(255, 255, 255)))
            self.textpos.append(self.text[len(self.text)-1].get_rect())
            #self.textpos[len(self.text)-1].centery = self.boundaryRect.top + self.boundaryRect.height/2
            #self.textpos[len(self.text)-1].centerx = self.boundaryRect.left + self.boundaryRect.width/2
            self.textpos[len(self.text)-1].center = self.boundaryRect.center
            
            self.text.append(self.fontMenu.render(self.label["new"],True,(60, 60, 66)))
            self.textpos.append(self.text[len(self.text)-1].get_rect())
            self.textpos[len(self.text)-1].left = 240
            self.textpos[len(self.text)-1].top = 220

            self.text.append(self.fontMenu.render(self.label["load"],True,(60, 60, 60)))
            self.textpos.append(self.text[len(self.text)-1].get_rect())
            self.textpos[len(self.text)-1].left = 240
            self.textpos[len(self.text)-1].top = self.textpos[len(self.text)-2].bottom + 15

            self.text.append(self.fontMenu.render(self.label["config"],True,(60, 60, 60)))
            self.textpos.append(self.text[len(self.text)-1].get_rect())
            self.textpos[len(self.text)-1].left = 240
            self.textpos[len(self.text)-1].top = self.textpos[len(self.text)-2].bottom + 15

            self.text.append(self.fontMenu.render(self.label["credit"],True,(60, 60, 60)))
            self.textpos.append(self.text[len(self.text)-1].get_rect())
            self.textpos[len(self.text)-1].left = 240
            self.textpos[len(self.text)-1].top = self.textpos[len(self.text)-2].bottom + 15

            self.text.append(self.fontLoose.render(self.label["complete"],True,(255, 255, 255)))
            self.textpos.append(self.text[len(self.text)-1].get_rect())
            self.textpos[len(self.text)-1].center = self.boundaryRect.center

            self.text.append(self.fontMassUnit.render("level 00",True,(255, 255, 255)))
            self.textpos.append(self.text[len(self.text)-1].get_rect())
            self.textpos[len(self.text)-1].top = 0
            self.textpos[len(self.text)-1].centerx = self.boundaryRect.centerx

            self.text.append(self.fontLoose.render(self.label["retry"],True,(255, 255, 255)))
            self.textpos.append(self.text[len(self.text)-1].get_rect())
            self.textpos[len(self.text)-1].top = self.textpos[6].bottom + 5
            self.textpos[len(self.text)-1].centerx = self.boundaryRect.left + self.boundaryRect.width/2
            

    def displayMenu(self):
        self.background = pygame.transform.scale(yumenokaze.load_image("menu.png","images"),(self.width, self.height))
        self.screen.blit(self.background, (0, 0))

        self.menuOptions=["new"]

        #surfMassUnit=self.fontMassUnit.render("%s" % self.astra.massUnit,True,(255, 255, 255))
        #self.text[1]=surfMassUnit

        self.selectedOption = 0
            

        while 1:
            #self.screen.blit(self.background, self.textpos[7],self.textpos[7])
            self.screen.blit(self.background, self.textpos[8],self.textpos[8])
            self.screen.blit(self.background, self.textpos[9],self.textpos[9])
            self.screen.blit(self.background, self.textpos[10],self.textpos[10])
            self.screen.blit(self.background, self.textpos[11],self.textpos[11])
            
            # Boucle de detection des touches appuyees
            for event in pygame.event.get():
                if event.type == pygame.QUIT: 
                    sys.exit()
                # Utiliser la pile des Events ne permet pas de detecter les appuis simultanes
                #elif event.type == KEYDOWN:
                    #if ((event.key == K_RIGHT)
                    #or (event.key == K_LEFT)
                    #or (event.key == K_UP)
                    #or (event.key == K_DOWN)):
                        #self.astra.move(event.key)
                elif event.type == KEYDOWN:
                    if (event.key == K_UP):
                        self.toogleMenuOption(-1)
                    elif (event.key == K_DOWN):
                        self.toogleMenuOption(1)
                    elif (event.key == K_RETURN):
                        if self.menuOptions[self.selectedOption] == "new": self.mainLoop(1)
                        if self.menuOptions[self.selectedOption] == "new": self.loadMenu()
                        if self.menuOptions[self.selectedOption] == "config": self.configMenu()
                        if self.menuOptions[self.selectedOption] == "credit": self.creditMenu()                        
                    elif (event.key == K_ESCAPE): sys.exit()

            if self.menuOptions[self.selectedOption] == "new":self.text[8]=self.fontMenu.render(self.label["new"],True,(180, 180, 216))
            elif self.menuOptions[self.selectedOption] == "load":self.text[9]=self.fontMenu.render(self.label["load"],True,(180, 180, 216))
            elif self.menuOptions[self.selectedOption] == "config":self.text[10]=self.fontMenu.render(self.label["config"],True,(180, 180, 216))
            elif self.menuOptions[self.selectedOption] == "credit":self.text[11]=self.fontMenu.render(self.label["credit"],True,(180, 180, 216))

            for option in self.menuOptions:
                if option != self.menuOptions[self.selectedOption]:
                    if option == "new":self.text[8]=self.fontMenu.render(self.label["new"],True,(180, 180, 146))
                    elif option == "load":self.text[9]=self.fontMenu.render(self.label["load"],True,(180, 180, 146))
                    elif option == "config":self.text[10]=self.fontMenu.render(self.label["config"],True,(180, 180, 146))
                    elif option == "credit":self.text[11]=self.fontMenu.render(self.label["credit"],True,(180, 180, 146))



            #self.screen.blit(self.text[7], self.textpos[7])
            self.screen.blit(self.text[8], self.textpos[8])
            self.screen.blit(self.text[9], self.textpos[9])
            self.screen.blit(self.text[10], self.textpos[10])
            self.screen.blit(self.text[11], self.textpos[11])
            
        
            pygame.display.flip()
            
    def toogleMenuOption(self,order):
        if order > 0:
            self.selectedOption = self.selectedOption + 1
            if self.selectedOption == len(self.menuOptions) : self.selectedOption = 0
        if order < 0:
            self.selectedOption = self.selectedOption - 1
            if self.selectedOption < 0 : self.selectedOption = len(self.menuOptions) - 1
        if self.debug : print "Menu Option is ",self.menuOptions[self.selectedOption]
        
    def loadMenu(self):
        if self.debug : print "Load Menu"

    def configMenu(self):
        if self.debug : print "Load Menu"

    def creditMenu(self):
        if self.debug : print "Load Menu"

    def levelCompleted(self):
        if self.debug: print "level completed!"
        loop = 1
        self.screen.blit(self.text[12], self.textpos[12])
        pygame.display.flip()
    
        while loop:
            pygame.time.wait(500)
            
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    sys.exit()
                elif event.type == KEYDOWN:
                    if (event.key == K_RETURN) or (event.key == K_e) or (event.key == K_r):
                        loop = 0
                        if self.debug: print "loading next level"
                        level = self.level+1
                        self.__init__()
                        #self.displayMenu()
                        self.mainLoop(level)
                        
                    elif (event.key == K_ESCAPE):
                        self.__init__()
                        self.displayMenu()
                        #sys.exit()


    def planetCollide2(self, group, dokill):
        crashed = []
        for p in group.sprites(): p.swapRect()
        crashed = yumenokaze.groupintercollide(group, dokill)
        for p in group.sprites(): p.swapRect()
        return crashed
            
    def planetcollide(self, group, dokill):
        crashed = []
        subgroup = group.copy()
        print "group is ",group
        for s in group.sprites():
            subgroup.remove(s)
            s.crash=0
            s.crashed=0
            print "s is ",s," subgroup is ",subgroup
            for sp in subgroup.sprites():
                sp.crashed=0
                #print "s.pathRect is", s.pathRect,"sp.pathRect is", s.pathRect
                if s.pathRect.colliderect(sp.pathRect):
                    s.crash=1
                    for c in crashed:
                        if c == sp : sp.crashed=1
                        if c == s: s.crashed=1
                    if sp.crashed != 1 : crashed.append(sp)
            if (s.crash == 1) and (s.crashed != 1) : crashed.append(s)
            if len(subgroup) == 1 : break
        if dokill:
            for cr in crashed: cr.kill()
        return crashed

    def applyForces(self):
        lstCollision=self.planetCollide2(self.planetes, False)
        blackedCollision=pygame.sprite.groupcollide(self.blackholes, self.planetes, False, False)
        if lstCollision:
            if self.debug: print lstCollision
            #sys.exit()
            for p in lstCollision:
                if p != self.astra:
                    yumenokaze.deleteFromList(p,self.lstPlanet)
                    #indexC = yumenokaze.belongList(p,self.lstPlanet)
                    #for i in indexC:
                        #del self.lstPlanet[i]
                    self.planetes.remove(p)
                else :
                    if self.debug: print "this is astra"
                    self.astra.lose(self)
                    
        if blackedCollision:
            if self.debug: print blackedCollision
            for b in blackedCollision.keys():
                for p in blackedCollision[b]:
                    if p != self.astra:
                        yumenokaze.deleteFromList(p,self.lstPlanet)
                        #indexB = yumenokaze.belongList(p,self.lstPlanet)
                        #for i in indexB:
                            #del self.lstPlanet[i]
                        self.planetes.remove(p)
                    else :
                        if self.debug: print "this is astra"
                        self.astra.lose(self)
                        
                #for i in indexB:
                    #del self.lstPlanet[i]

        if self.life == 0 : self.gameover()
        
        if self.life > 0:
            for p in self.lstPlanet:
                p.update(p.forceX,p.forceY)

    def checkSlots(self):
        #for s in self.lstSlot:
        slotCollision = pygame.sprite.groupcollide(self.slots, self.planetes, False, False)
        for p in self.lstPlanet: p.prevSlotted = p.slotted
        for p in self.lstPlanet: p.slotted = 0
        self.slottedPlanets = 0
        if slotCollision:
            if self.debug: print slotCollision
            for s in slotCollision.keys():
                for p in slotCollision[s]:
                    if p.name == s.name:
                        p.slotted = 1
                        #if p.prevSlotted:
                            #print "already slotted"
                        #else:
                            #p.rect.center = s.rect.center
                            ##p.slotted = 1
                            ##p.rect.centerx = (6 * p.rect.centerx / 7 )+ (s.rect.centerx / 7)
                            ##p.rect.centery = (6 * p.rect.centery / 7 ) + (s.rect.centery / 7)
                            #self.slottedPlanets = self.slottedPlanets + 1
                        if (p.forceX >= 1) or (p.forceY >= 1):
                            if self.debug: print "deslotting the planet"
                        else:
                            #p.rect.center = s.rect.center
                            #p.slotted = 1
                            p.rect.centerx = (6 * p.rect.centerx / 7 )+ (s.rect.centerx / 7)
                            p.rect.centery = (6 * p.rect.centery / 7 ) + (s.rect.centery / 7)
                            self.slottedPlanets = self.slottedPlanets + 1
        if self.debug: print "self.slottedPlanets = ",self.slottedPlanets
        
    def debug(self):
        for p in self.lstPlanet:
            print "name is ", p.name,"; forceX is", p.forceX, "; forceY is", p.forceY
            print "posX is ",p.rect.left,"posY is ",p.rect.top

    def pause(self):
        loop = 1
        self.screen.blit(self.text[7], self.textpos[7])
        pygame.display.flip()
    
        while loop:
            pygame.time.wait(500)
            
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    sys.exit()
                elif event.type == KEYDOWN:
                    if (event.key == K_p):
                        loop = 0
                        self.screen.blit(self.background, self.textpos[7],self.textpos[7])
                        pygame.display.flip()
                    elif (event.key == K_ESCAPE):
                        self.__init__()
                        self.displayMenu()
                        #sys.exit()

    def gameover(self):
        loop = 1
        self.screen.blit(self.text[6], self.textpos[6])
        self.screen.blit(self.text[14], self.textpos[14])
        pygame.display.flip()
    
        while loop:
            pygame.time.wait(500)
            
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    self.__init__()
                    self.displayMenu()
                    sys.exit()
                elif event.type == KEYDOWN:
                    if (event.key == K_RETURN) or (event.key == K_e) or (event.key == K_r):
                        loop = 0
                        level = self.level
                        self.__init__()
                        self.mainLoop(level)
                        #self.screen.blit(self.background, self.textpos[11],self.textpos[11])
                        #pygame.display.flip()
                        print "loading next level"
                    elif (event.key == K_ESCAPE): sys.exit()

    def translateText(self, language):

        self.label = {}

        self.label["loose"]="Game Over"
        self.label["mass"]="mass"
        self.label["pause"]="Pause"
        self.label["new"]="New game"
        self.label["load"]="Load a game"
        self.label["config"]="Configuration"
        self.label["credit"]="Credits"
        self.label["complete"]="Level completed"
        self.label["level"]="level"
        self.label["retry"]="Press ENTER to try again"
        

        if language == "en":
            self.label["loose"]="Game Over"
            self.label["mass"]="mass"
            self.label["pause"]="Pause"
            self.label["new"]="New game"
            self.label["load"]="Load a game"
            self.label["config"]="Configuration"
            self.label["credit"]="Credits"
            self.label["complete"]="Level completed"
            self.label["level"]="level"
            self.label["retry"]="Press ENTER to try again"
        
        elif language == "fr":
            self.label["loose"]="Perdu"
            self.label["mass"]="masse"
            self.label["pause"]="Pause"
            self.label["new"]="Nouvelle partie"
            self.label["load"]="Charger une partie"
            self.label["config"]="Configuration"
            self.label["credit"]="Credits"
            self.label["complete"]="Niveau fini"
            self.label["level"]="niveau"
            self.label["retry"]="Pressez ENTER pour recommencer"
        
        

    def loadLevel(self,level):
        self.level = level
        if self.debug: print "self.level is ",self.level

        if self.level == 1:
            self.background = pygame.transform.scale(yumenokaze.load_image("background.png","images"),(self.width, self.height))
            self.screen.blit(self.background, (0, 0))

            surfLevel=self.fontMassUnit.render("%s %s" % (self.label["level"], self.level),True,(255, 255, 255))
            self.text[13]=surfLevel
            self.screen.blit(self.text[13], self.textpos[13])


            self.astra = Astra(self.boundaryRect, "astra", (24,24), "p56.gif", 50 ,50, (1,24))
            self.lstPlanet.append(self.astra)
               
            self.mondo = Planet(self.boundaryRect, "mondo", (24,24), "p24.gif", 550, 80, (8,24))
            self.lstPlanet.append(self.mondo)

            self.planetes = pygame.sprite.Group()

            for p in self.lstPlanet:
                self.planetes.add(p)
            if self.debug: print "self.planetes is",self.planetes

            self.blackholes = pygame.sprite.Group()
            for b in self.lstBlackHole:
                self.blackholes.add(b)

            self.mondoSlot = Slot("mondo", 12, (168,101,72), 430 ,350)
            self.lstSlot.append(self.mondoSlot)
            self.slots = pygame.sprite.Group()
            for s in self.lstSlot:
                self.slots.add(s)

            self.slottedPlanets = 0

        elif self.level == 2:
            self.background = pygame.transform.scale(yumenokaze.load_image("background.png","images"),(self.width, self.height))
            self.screen.blit(self.background, (0, 0))

            surfLevel=self.fontMassUnit.render("%s %s" % (self.label["level"], self.level),True,(255, 255, 255))
            self.text[13]=surfLevel
            self.screen.blit(self.text[13], self.textpos[13])


            self.astra = Astra(self.boundaryRect, "astra", (24,24), "p56.gif", 50 ,50, (1,24))
            self.lstPlanet.append(self.astra)
               
            self.mondo = Planet(self.boundaryRect, "mondo", (24,24), "p24.gif", 500, 120, (8,23))
            self.lstPlanet.append(self.mondo)

            self.terra = Planet(self.boundaryRect, "terra", (36,36), "p12.gif", 400, 460, (2,24))
            self.lstPlanet.append(self.terra)
        
            self.planetes = pygame.sprite.Group()

            for p in self.lstPlanet:
                self.planetes.add(p)
            if self.debug: print "self.planetes is",self.planetes

            self.blackholes = pygame.sprite.Group()
            for b in self.lstBlackHole:
                self.blackholes.add(b)

            self.mondoSlot = Slot("mondo", 12, (168,101,72), 300 ,410)
            self.terraSlot = Slot("terra", 12, (132,168,102), 360 ,100)

            self.lstSlot.append(self.mondoSlot)
            self.lstSlot.append(self.terraSlot)

            self.slots = pygame.sprite.Group()
            for s in self.lstSlot:
                self.slots.add(s)

            self.slottedPlanets = 0

        elif self.level == 3:
            self.background = pygame.transform.scale(yumenokaze.load_image("background.png","images"),(self.width, self.height))
            self.screen.blit(self.background, (0, 0))

            surfLevel=self.fontMassUnit.render("%s %s" % (self.label["level"], self.level),True,(255, 255, 255))
            self.text[13]=surfLevel
            self.screen.blit(self.text[13], self.textpos[13])


            self.astra = Astra(self.boundaryRect, "astra", (24,24), "p56.gif", 50 ,50, (1,25))
            self.lstPlanet.append(self.astra)
               
            self.mondo = Planet(self.boundaryRect, "mondo", (24,24), "p24.gif", 300, 200, (3,24))
            self.lstPlanet.append(self.mondo)

            self.terra = Planet(self.boundaryRect, "terra", (36,36), "p12.gif", 500, 400, (6,24))
            self.lstPlanet.append(self.terra)
        
            self.bh = BlackHole(self.boundaryRect, "blackhole", (64,64), "blackhole.png", 50, 350, (1,25))
            self.lstBlackHole.append(self.bh)

            self.planetes = pygame.sprite.Group()

            for p in self.lstPlanet:
                self.planetes.add(p)
            if self.debug: print "self.planetes is",self.planetes

            self.blackholes = pygame.sprite.Group()
            for b in self.lstBlackHole:
                self.blackholes.add(b)

            self.mondoSlot = Slot("mondo", 12, (168,101,72), 80 ,70)
            self.terraSlot = Slot("terra", 12, (132,168,102), 500 ,130)

            self.lstSlot.append(self.mondoSlot)
            self.lstSlot.append(self.terraSlot)

            self.slots = pygame.sprite.Group()
            for s in self.lstSlot:
                self.slots.add(s)

            self.slottedPlanets = 0



        lifeSpriteOffset = self.boundaryRect.right
        i = 0
        while i < self.life:
            lifeSprite = pygame.sprite.Sprite()
            lifeSprite.image = pygame.transform.scale(yumenokaze.load_image("p56.gif","images"),(20,20))
            lifeSprite.rect =  lifeSprite.image.get_rect()
            lifeSpriteOffset = lifeSpriteOffset - lifeSprite.rect.width - 5
            lifeSprite.rect.left = lifeSpriteOffset
            self.lives.append(lifeSprite)
            i = i + 1
        if self.debug: print self.lives
        
                    
class BlackHole(pygame.sprite.Sprite):
    debug = 0
    def __init__( self, boundaryRect, name, (width, height), img, x_pos, y_pos, (massUnit, massExp) ):
     #def __init__( self, name, radius, color, x_pos, y_pos, (massUnit, massExp) ):
        pygame.sprite.Sprite.__init__( self )

        self.name = name

        self.image = pygame.transform.scale(yumenokaze.load_image(img,"images"),(width, height))
        #self.image = pygame.Surface(( 2 * radius, 2 * radius )).convert( )

        #self.rect = self.image.get_rect( )

        #pygame.draw.circle(self.image, color, (radius, radius), radius)
                
        self.rect = self.image.get_rect( )

        self.rect.left = x_pos
        self.rect.bottom = y_pos

        self.boundaryRect = boundaryRect

        self.massUnit = massUnit
        self.massExp = massExp

    def update( self, x, y ):
        #Evite qu'un corps astral sorte malencontreusement de l'ecran
        #if (self.rect.right + x) >= (self.boundaryRect.right-5): x = self.boundaryRect.right-5 - self.rect.right
        #if (self.rect.left + x) <= (self.boundaryRect.left+5): x = self.boundaryRect.left+5 - self.rect.left
        #if (self.rect.bottom + y) >= (self.boundaryRect.bottom-5): y = self.boundaryRect.bottom-5 - self.rect.bottom
        #if (self.rect.top + y) <= (self.boundaryRect.top+5): y = self.boundaryRect.top+5 - self.rect.top

        if ((self.rect.right + x) >= (self.boundaryRect.right)) or ((self.rect.left + x) <= (self.boundaryRect.left)) or ((self.rect.bottom + y) >= (self.boundaryRect.bottom)) or ((self.rect.top + y) <= (self.boundaryRect.top)):
            if self.name == "astra": self.lose()
            else : self.massUnit = 0
            

        
        #if (self.rect.right >= (self.boundaryRect.right-5)) and (x > 0): x = 0
        #if (self.rect.left <= (self.boundaryRect.left+5)) and (x < 0): x = 0
        #if (self.rect.bottom >= (self.boundaryRect.bottom-5)) and (y > 0): y = 0
        #if (self.rect.top <= (self.boundaryRect.top+5)) and (y < 0): y = 0
            
        self.rect.move_ip( x, y )
        if BlackHole.debug:
            print "update"
            print "self.rect.left is ",self.rect.left," self.pathRect.left is ",self.pathRect.left

class Planet(BlackHole):
    debug = 0
    def __init__( self, boundaryRect, name, (width, height), img, x_pos, y_pos, (massUnit, massExp) ):
    #def __init__( self, name, radius, color, x_pos, y_pos, (massUnit, massExp) ):
        BlackHole.__init__( self, boundaryRect, name, (width, height), img, x_pos, y_pos, (massUnit, massExp) )
        #BlackHole.__init__( self, name, radius, color, x_pos, y_pos, (massUnit, massExp) )
        
        self.pathRect = pygame.Rect(self.rect)
        self.oldRect = pygame.Rect(self.rect)

        self.slotted = 0
        self.prevSlotted = 0
        

        if Planet.debug == 1: BlackHole.debug = 1


    def computeForces(self, lstPlanet, lstBlackHole):
        (self.forceX,self.forceY) = (0,0)
        #self.pathRect = pygame.Rect(self.rect)
        
        for p in lstPlanet:
            if p != self:
                self.computeOneForce(p)
        for b in lstBlackHole:
            self.computeOneForce(b)
            
        # calcul du pathRect
        if Planet.debug:
            print "== before computing =="
            print "self.rect.left is ",self.rect.left," self.pathRect.left is ",self.pathRect.left
            print "self.forceX is ",self.forceX," self.forceY is ",self.forceY
        self.forceX = round(self.forceX)
        self.forceY = round(self.forceY)
        

        self.pathRect.left = self.rect.left
        left = self.rect.left
        if self.forceX < 0:            
            #if abs(self.forceX) > 1: self.pathRect.left = self.pathRect.left + self.forceX
            self.pathRect.left = self.pathRect.left + self.forceX
        self.pathRect.width = self.rect.width + abs(self.forceX)
        self.pathRect.top = self.rect.top
        if self.forceY < 0:
            #if abs(self.forceY) > 1: self.pathRect.top = self.pathRect.top + self.forceY
            self.pathRect.top = self.pathRect.top + self.forceY
        self.pathRect.height = self.rect.height + abs(self.forceY)
        
        if Planet.debug: print "self.rect.left is ",self.rect.left," self.pathRect.left is ",self.pathRect.left

    def computeOneForce(self, p):
        if p.rect.center != self.rect.center:
            distX = p.rect.centerx - self.rect.centerx
            distXX = distX ** 2
            distY = p.rect.centery - self.rect.centery
            distYY = distY ** 2
            localeForceUnit = self.massUnit * p.massUnit * 6.7/(distXX + distYY)
            localeForceExp = self.massExp + p.massExp - 46
            localeForce = localeForceUnit * (10 ** localeForceExp)

            #if abs(distX) < 5:
                #localeForceX = 0
                #localeForceY = localeForce
            #elif abs(distY) < 5:
                #localeForceX = localeForce
                #localeForceY = 0
            #else:
                #localeForceX = distX * localeForce / math.sqrt(distXX + distYY)
                #localeForceY = distY * localeForce / math.sqrt(distXX + distYY)

            localeForceX = distX * localeForce / math.sqrt(distXX + distYY)
            localeForceY = distY * localeForce / math.sqrt(distXX + distYY)


            if Planet.debug: print "distX is ",distX," distY is ",distY
            if Planet.debug: print "localeForce is ",localeForce
            if Planet.debug: print "localeForceX is ",localeForceX," localeForceY is ",localeForceY
            if Planet.debug: print "Old self.forceX is ",self.forceX," self.forceY is ",self.forceY

            

            self.forceX = self.forceX + localeForceX
            self.forceY = self.forceY + localeForceY

            #if p.rect.centerx < self.rect.centerx:
                #self.forceX = self.forceX - localeForceX
            #else:
                #self.forceX = self.forceX + localeForceX

            #if p.rect.centery < self.rect.centery:
                #self.forceY = self.forceY - localeForceY
            #else:
                #self.forceY = self.forceY + localeForceY
            if Planet.debug: print "New self.forceX is ",self.forceX," self.forceY is ",self.forceY



    def vibrate(self):
        vibe=0

    def swapRect(self):
        self.oldRect = self.rect
        self.rect = self.pathRect
        self.pathRect = self.oldRect

    def kill(self):
        pygame.sprite.Sprite.kill(self)
        if Planet.debug: print "collision!"
        #print "collision!"


class Astra(Planet):
    debug = 0
    def __init__( self, boundaryRect, name, (width, height), img, x_pos, y_pos, (massUnit, massExp) ):
    #def __init__( self, boundaryRect, name, radius, color, x_pos, y_pos, (massUnit, massExp) ):
        Planet.__init__( self, boundaryRect, name, (width, height), img, x_pos, y_pos, (massUnit, massExp) )
        #Planet.__init__(self, name, radius, color, x_pos, y_pos, (massUnit, massExp))

        self.x_dist = 3
        self.y_dist = 3

        self.x_orig = x_pos
        self.y_orig = y_pos
        
        self.boundaryRect = boundaryRect

        self.massUnit_orig=massUnit
        self.massExp_orig=massExp

        self.collided = 0
        

    def move(self, key):
        xMove = 0;
        yMove = 0;
        
        if (key == K_RIGHT):
            if self.rect.right >= (self.boundaryRect.right-5) : xMove = 0
            else : xMove = self.x_dist
        elif (key == K_LEFT):
            if self.rect.left <= (self.boundaryRect.left+5) : xMove = 0
            else : xMove = -self.x_dist
        elif (key == K_UP):
            if self.rect.top <= (self.boundaryRect.top+5) : yMove = 0
            else : yMove = -self.y_dist
        elif (key == K_DOWN):
            if self.rect.bottom >= (self.boundaryRect.bottom-5) : yMove = 0
            else : yMove = self.y_dist

        self.update(xMove,yMove)

    #def update( self, x, y ):
        #self.rect.move_ip( x, y )
        #print "update"
        #print "self.rect.left is ",self.rect.left," self.pathRect.left is ",self.pathRect.left

    def changeMass(self, order):
        if Astra.debug: print "order is ",order," massUnit is ",self.massUnit," massExp is",self.massExp
        if (order > 0) and (self.massExp < 31):
            if self.massUnit == 1 :
                self.massUnit = 5
            else:
                self.massExp = self.massExp+1
        elif (order < 0) and (self.massExp > 19):
            if self.massUnit == 1 :
                self.massUnit = 5
                self.massExp = self.massExp-1
            else:
                self.massUnit = 1
        if Astra.debug: print "New massUnit is ",self.massUnit," New massExp is",self.massExp

    def lose(self,parent):
        if Astra.debug:
            print "Astra collision!"
            print parent.lives
        del parent.lives[0]
        life = len(parent.lives)
        if Astra.debug: print "Remaining lives: ",life
        if life == 0:
            if Astra.debug: print "Game Over!"
            parent.gameover()
            #sys.exit()
        if Astra.debug: print "New position is: ",self.x_orig, self.y_orig
        self.rect.left = self.x_orig
        self.rect.top = self.y_orig
        self.forceX = 0
        self.forceY = 0
        self.massUnit=self.massUnit_orig
        self.massExp=self.massExp_orig
        self.collided = 1
        if Astra.debug: print "Set self.collided to 1"
        
    def update( self, x, y ):
        if ((self.rect.right + x) >= (self.boundaryRect.right)) or ((self.rect.left + x) <= (self.boundaryRect.left)) or ((self.rect.bottom + y) >= (self.boundaryRect.bottom)) or ((self.rect.top + y) <= (self.boundaryRect.top)):
            if self.collided:
                if Astra.debug: print "Set self.collided to 0"
            else :
                if Astra.debug: print "Out of screen"
                self.lose()
                
        if self.collided: self.collided = 0
        else : self.rect.move_ip( x, y )
        #self.rect.move_ip( x, y )
        if Planet.debug:
            print "update"
            print "self.rect.left is ",self.rect.left," self.pathRect.left is ",self.pathRect.left
   

class Slot(pygame.sprite.Sprite):
    debug = 0
    def __init__( self, name, radius, color, x_pos, y_pos):
        pygame.sprite.Sprite.__init__( self )

        self.name = name

        self.image = pygame.Surface(( 2 * radius, 2 * radius )).convert( )

        self.rect = self.image.get_rect( )

        pygame.draw.circle(self.image, color, (radius, radius), radius, 1)
                
        self.rect.left = x_pos
        self.rect.bottom = y_pos


if __name__ == "__main__":
    mainWindow = AstraMain()
    mainWindow.displayMenu()
    #mainWindow.mainLoop()
